<template>
  <validation-provider
    v-slot="{ errors }"
    :name="field.name"
    :rules="field.rules"
  >
    <v-autocomplete
      outlined
      v-model="v"
      :error-messages="errors"
      :items="options"
      :prepend-icon="field.icon"
      :name="field.id"
      :label="field.name"
      :item-value="field.valField || 'value'"
      :item-text="field.textField || 'name'"
    />
  </validation-provider>
</template>

<script lang="ts">
import Vue from 'vue'
import { Field } from '../../util/field'

export default Vue.extend({
  name: 'enum-field',
  props: {
    field: { type: Object as () => Field, required: true },
    value: { type: String }
  },
  data () {
    return {
      menu: false,
      options: [] as unknown[]
    }
  },
  async mounted () {
    if (this.field.type === 'enum') {
      if (this.field.options instanceof Function) this.options = await this.field.options(this.field)
      else this.options = this.field.options
    }
  },
  computed: {
    v: {
      get (): string {
        return this.value
      },
      set (v: string) {
        this.menu = false
        this.$emit('input', v)
      }
    }
  }
})
</script>
